      program nplot

      open(unit=21,file='nstabplt')   ! Input file for plot
      call opngks
      call plot
      call plotit(0,0,0)
      call clsgks

      end

      subroutine plot
c
c     read and plot all data
c
c
      parameter (ns1=12,nuf1=21,nvf1=21,Q1=1)

      parameter (numsfd=500)
      parameter (nsdd=2*ns1)
      parameter (numpd=1200)
      integer step,pmod
c     NCAR uses real*4 variables
      real*4 xp2(0:numpd),yp2(0:numpd),w,x0i,y0i
      real*4 xp3(0:numsfd,0:nsdd),yp3(0:numsfd,0:nsdd)
      real*4 xstart,ystart,bd,axmax,mx
      real*4 errpp(numpd,10)

c     for plotting the flux surfaces, evaluate the Fourier series at
c     at least 72 points for a smooth curve.  A multiple of nu points
c     in u is used so that the rays can be easily plotted
c     and they will be at the true mesh points (assuming the v=const
c     cross section is on an exact v mesh point which is only the case
c     when nv is a multple of 4).

      read(21,997) nu

      numray=nu
      numsf=(72/numray + 1 ) * numray
      if (numsf.gt.numsfd) then
          write(7,*) 'numsf > numsfd, no plots produced'
          return
      endif

      read(21,997) nump
      do jj=1,nump
         read(21,999) (errpp(jj,kk),kk=1,5)
      enddo

      call agseti('FRAME.',2)
c     set all lines to be solid (not dashed)
      call dashdc('$',20,12)
c     line thickness 2x normal
c     call gslwsc(real(lthick))
      call gslwsc(1.0)

      read(21,999) axmax

c     plot 4 Poincare sections of the torus

      do 400 kp=1,1           !!??!!     normally  0,3
      v=kp*.25
      xstart=mod(kp,1)*1.0      !!??!!   normally .5
      ystart=(1-(kp/1))*1.0      !!??!!   normally .5
      bd=.30

c     coordinate system     !!??!!   normally  .5  below
      call set(xstart,xstart+1.0,ystart,ystart+1.0,-axmax*(1+bd),
     $     axmax*(1+bd),-axmax*(1+bd),axmax*(1+bd),1)
c     call line(-axmax,0.,axmax,0.)     !!??!!!
c     call line(0.,-axmax,0.,axmax)     !!??!!!

      read(21,997) ns,step,numsf

      do 230 i=ns,0,-step
         read(21,999) (xp3(j2,i),yp3(j2,i),j2=0,numsf)
         call curved(xp3(0,i),yp3(0,i),numsf+1)
230   continue

c     plot axis

      read(21,999) x0i,y0i

      call gsmksc(.25)
      call points(x0i,y0i,1,-4,0)
      call gsmksc(.10)
      call points(x0i,y0i,1,-4,0)
      call plotit(0,0,0)

400   continue

      read(21,997) nprint,nump,pmod

      if (nprint.ge.1 .and. nump.gt.0) then
c        L2 error plot
         call frame
         do 600 i=1,nump
600         xp2(i)=i*pmod
         xstart=0
         ystart=.5
         bd=.10
         call set(xstart+bd,xstart+1.-bd,ystart+bd/4,ystart+.5-bd/4,
     $   .1,1.,.1,1.,2)
         call agseti('SET.',2)
c        turn off clipping
         call gsclip(0)

c        set size of axis labels and numbers
         w=2
         call agsetc('LABEL/NAME.','L')
         call agsetp('LINE/NU.',100.,1)
         call agsetp('LINE/CHAR.',.015*w,1)
         call agsetp('LEFT/WIDTH/MA.',.015*w,1)
         call agsetp('LEFT/WIDTH/EX.',.010*w,1)
         call agsetc('LABEL/NAME.','B')
         call agsetp('LINE/NU.',-100.,1)
         call agsetp('LINE/CHAR.',.015*w,1)
         call agsetp('BOTTOM/WIDTH/MA.',.015*w,1)
         call agsetp('BOTTOM/WIDTH/EX.',.010*w,1)
         call agsetp('LABEL/OFFSET/Y.',-.05,1)

         call anotat(' ','L2 ERROR',3,0,0,0)
         call agsetp('LEFT/MAJOR/COUNT.',0.,1)
         call agsetp('LEFT/MINOR/SPACING.',0.,1)
         call agsetp('BOTTOM/MAJOR/COUNT.',0.,1)
         call agsetp('BOTTOM/MINOR/SPACING.',0.,1)
         call agstup(xp2(1),1,0,nump,1,errpp,3,numpd,nump,1)
         call agback
         call agcurv(xp2(1),1,errpp(1,1),1,nump,1)
         call agcurv(xp2(1),1,errpp(1,2),1,nump,1)
         call agcurv(xp2(1),1,errpp(1,3),1,nump,1)
         call plchhq(xp2(nump),errpp(nump,1),' R',.012,0.,-1.)
         call plchhq(xp2(nump),errpp(nump,2),' F',.012,0.,-1.)       !
         call plchhq(xp2(nump),errpp(nump,3),' X',.012,0.,-1.)

c        mode plot convergence plot
         xstart=.15      !!??!! before .5
         ystart=.0
         call set(xstart+bd,xstart+.7-bd,ystart+bd,ystart+.5-bd,
     $   .1,1.,.1,1.,1)
         call agseti('SET.',2)

c        size of axis labels and numbers
         w=3
         call agsetc('LABEL/NAME.','L')
         call agsetp('LINE/NU.',100.,1)
         call agsetp('LINE/CHAR.',.015*w,1)
         call agsetp('LEFT/WIDTH/MA.',.015*w,1)
         call agsetp('LEFT/WIDTH/EX.',.010*w,1)
         call agsetc('LABEL/NAME.','B')
         call agsetp('LINE/NU.',-100.,1)
         call agsetp('LINE/CHAR.',.015*w,1)
         call agsetp('LABEL/OFFSET/Y.',-.05,1)
         call agsetp('BOTTOM/WIDTH/MA.',.015*w,1)
         call agsetp('BOTTOM/WIDTH/EX.',.010*w,1)

         call agsetp('LEFT/MAJOR/COUNT.',0.,1)
         call agsetp('LEFT/MINOR/SPACING.',0.,1)

         call anotat('ITERATIONS','MODE',3,0,0,0)
         call agsetf('AXIS/BOTTOM/CONTROL.',-1.)
         call ezy(errpp(1,5),nump,' ')

      endif
   
      return

 997  format(4i8)
 999  format(6e12.6)
      end
